import swarm.*;
import swarm.objectbase.*;
import swarm.defobj.*;
import swarm.space.*;
import swarm.gui.*;
import java.util.*;
//2HƉa[hɐݒ肷
public class RandomMaze extends Discrete2dImpl{


  public RandomMaze(Zone aZone,int x,int y){
    super(aZone,x,y);
  }

  public Object nullMap(){
    int x,y;
    int xsize,ysize;

    xsize=this.getSizeX();
    ysize=this.getSizeY();
    for (y = 0; y < ysize; y++) {
      for (x = 0; x < xsize; x++) {
        this.putValue$atX$Y(0,x,y);
      }
    }
    return this;
  }

  private int m_x1,m_y1,m_x2,m_y2,m_s1,m_s2;
  //a̐ݒuꏊƋ`̑傫߂
  public void setFoodParams(int x1, int y1, int s1,int x2, int y2, int s2){
    m_x1 = x1;
    m_y1 = y1;
    m_s1 = s1;
    m_y2 = y2;
    m_x2 = x2;
    m_s2 = s2;    
  }
  //ʂ̉h{ubNu
  private Object giveFoodEach(int x,int y,int size){
    int xsize,ysize,i,j,tysize,txsize,tyysize,txxsize;
    
    xsize=this.getSizeX();
    ysize=this.getSizeY();      
    
    txsize = size + x;
    tysize = size + y;
    tyysize=-size + y;
    txxsize=-size + x;
    for(i = txxsize;i < txsize;i++ ){
      for(j = tyysize;j < tysize; j++){
        if( i >= 0 && j  >= 0 && i  <= xsize && j <= ysize) {
          this.putValue$atX$Y(2,i,j); 
        }
      }
    }
    return this;
  }
  //aݒu
  public Object giveFoodSpace(){
     giveFoodEach(m_x1,m_y1,m_s1);
     giveFoodEach(m_x2,m_y2,m_s2);     
    return this;
  }

  //@@ɂHݒu
  public Object giveMaze(){
    int i,j,k,l;
    int[][] block = new int[23][23];
    int cur,dir,newPosX,newPosY;
    ArrayList<Vector<Integer>> lookVecs = new ArrayList<Vector<Integer>>();
    
    boolean digging = true,findSpace=false;

    Vector<Integer> v;
    ArrayList<Vector<Integer>> s = new ArrayList<Vector<Integer>>();
    
    //intialize block
    //20}X̃ubNHzł炩ߍ쐬 
    for(i = 0; i < 23; i++){
      for(j = 0; j< 23; j++){
        if (i == 0 || i == 22 || j == 0 || j == 22){
          block[j][i] = 0;
        }else{
          block[j][i] = 1;
        }
      }
    }

    

    lookVecs.add(getVec(0,2));
    lookVecs.add(getVec(0,-2));
    lookVecs.add(getVec(2,0));    
    lookVecs.add(getVec(-2,0));    

    //start-digging position
    s.add(getVec(10,10));    
    //construct randomized block maze (digging method)
    while(s.size() > 0){
      if(digging){
        v = s.get(s.size() - 1);
        Collections.shuffle(lookVecs);
        findSpace=false;
        for (dir = 0; dir < 4; dir++){
          newPosX=lookVecs.get(dir).get(0) + v.get(0);
          newPosY=lookVecs.get(dir).get(1) + v.get(1);
          if( block[newPosX][newPosY] == 1){
            
            block[newPosX][newPosY] = 0;
            block[lookVecs.get(dir).get(0)/2 +  v.get(0)][lookVecs.get(dir).get(1)/2 + v.get(1)] = 0;

            s.add(getVec(newPosX,newPosY));
            findSpace = true;
            break;
          }
        }
        if(!findSpace){
          s.remove(v);
          digging=false;          
        }
          
      }else{
        cur = Globals.env.uniformIntRand.getIntegerWithMin$withMax(0,s.size() - 1);
        v  =  s.get(cur);
        s.remove(v);
        s.add(v);
        digging = true;
      }
    }
    int centerX,centerY;
    int maxNum = 6;
    int centNum = maxNum / 2;
    //쐬ubNHSwarm̃[hW̕ǂɕϊ
    //grow wall blocks on the swarm world (200 x 200)
    for(i = 1; i < 22; i++){
      for(j = 1;j<22;j++){
        centerX = i * maxNum - centNum;
        centerY = j * maxNum - centNum;
        if(1==block[j][i]){
          //construt center block
          this.putValue$atX$Y(1,centerX,centerY);
          //create walls
          if(1==block[j-1][i]){
            for(k=1;k<=centNum;k++){
              this.putValue$atX$Y(1,centerX,centerY - k);
            }
          }
          if(1==block[j+1][i]){
            for(k=1;k<centNum;k++){
              this.putValue$atX$Y(1,centerX,centerY + k);
            }
          }
          if(1==block[j][i-1]){
            for(k=1;k<=centNum;k++){
              this.putValue$atX$Y(1,centerX - k,centerY);
            }
          }
          if(1==block[j][i+1]){
            for(k=1;k<centNum;k++){
              this.putValue$atX$Y(1,centerX + k,centerY);
            }
          }
        }else{
          for(k=1;k<=maxNum;k++){
            for(l=1;l<=maxNum;l++){
              this.putValue$atX$Y(0,i * maxNum - k,j * maxNum - k);
            }
          }
        }
      }
    }
    //R\[o
    for(i = 0; i < 23; i++){
      for(j = 0; j< 23; j++){
        if (block[j][i] == 1){
          System.out.print("#");
        }else{
          System.out.print(" ");
        }
      }
      System.out.print("\n");
    }    
    this.giveFoodSpace();
    return this;
  }
  public void step()
  {
    ;
  }
  private static Vector<Integer> getVec(int x,int y){
    Vector<Integer> v = new Vector<Integer>();
    v.add(x);
    v.add(y);
    return v;
  }
    
  
}
//    
//    } catch (Exception e) {
//        System.out.println("oops");
//    }    
    //intialize block $B"-(Bj $B"*(Bi
//    for(i = 0; i < 23; i++){
//      for(j = 0; j< 23; j++){
//        if (block[j][i] == 1){
//          System.out.print("#");
//        }else{
//          System.out.print(" ");
//        }
//      }
//      System.out.print("\n");
//    }